Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.
Note:
The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.
Example 1:
Given nums = [1, -1, 5, -2, 3]
, k = 3
,
return 4
. (because the subarray [1, -1, 5, -2]
sums to 3 and is the longest)
Example 2:
Given nums = [-2, -1, 2, 1]
, k = 1
,
return 2
. (because the subarray [-1, 2]
sums to 1 and is the longest)
Follow Up:
Can you do it in O(n) time?
本题和Minimum Size Subarray Sum有点类似之处,那道题的nlongn的做法里面,使用了二分查找,这里面的target和那道题的target比较类似,但是并不是用二分查找做出来的,而是存储一个hashmap来寻找,代码如下:
1 public class Solution { 2 public int maxSubArrayLen(int[] nums, int k) { 3 Map<Integer,Integer> map = new HashMap<Integer,Integer>(); 4 int sum = 0; 5 int len = 0; 6 for(int i=0;i<nums.length;i++){ 7 sum+=nums[i]; 8 if(sum==k) len = i+1; 9 else if(map.containsKey(sum-k)) len=Math.max(len,i-map.get(sum-k)); 10 if(!map.containsKey(sum)) map.put(sum,i); 11 } 12 return len; 13 } 14 }